function X = WormMC(edgeWeights,edgeStruct,burnin, X_init )
% Worm algorithm
nNodes = edgeStruct.nNodes;
nEdges = edgeStruct.nEdges;
edgeEnds = edgeStruct.edgeEnds;
nDegree = sum(edgeStruct.adj,2);
X = X_init;
OddX = [];

for r = 1:100000
    % try to sample 2 regular loop multiple times, if we fail, output
    % arbitrary 2 regular loop.
    t = 0;
    while t < burnin 
        if isempty(OddX)
            u = randi([1, nNodes], 1);
        else
            u = OddX(randi([1,2], 1),1);
        end
        nbr_u = find(edgeEnds(:,1) == u | edgeEnds(:,2) == u);
        if(length(nbr_u) ~= nDegree(u,1))
            keyboard;
        end
        uv = nbr_u(randi([1, nDegree(u,1)],1),1);
        uv_edge = edgeEnds(uv, :);
        v = uv_edge(uv_edge~=u);
        pm = -2*X(uv, 1) + 1;
        
        if isempty(OddX)
            prob_flip = min([1, edgeWeights(uv, 1)^pm]);
        elseif ~isempty(find(OddX == v,1))
            prob_flip = min([1, edgeWeights(uv, 1)^pm]);
        else
            prob_flip = min([1,  nDegree(u,1) / nDegree(v,1) * edgeWeights(uv, 1)^pm]);
        end
        coin = rand(1);
        if coin < 0.5 * prob_flip
            X(uv, 1) = ~X(uv, 1);
            if isempty(OddX)
                OddX = [u,v]';
            elseif isempty(find(OddX == v, 1))
                OddX = [OddX(OddX ~= u), v]';
            else
                OddX = [];
            end
        end
        
        t= t+1;
    end
    if isempty(OddX)
        break;
    end
end

if ~isempty(OddX)
    X = zeros(nEdges,1);
end
end